'use strict';
var chalk = require("chalk");
var path = require("path");
var bass = require("./bass");

var libPath = `${process.platform}-${process.arch}`;
var options = {
  basePath: path.join(__dirname, "libbass", libPath),
}

// create an instance of basslib
var basslib = new bass(options);

// Get version of loaded bass library
console.log(chalk.bgBlack.white.bold("Version is: " + basslib.BASS_GetVersion()));
